function [u,uInit]=solverPRLS(Y,x,A,At,Params,AtA,Omega)
%profile on
if nargin<7
   Omega=ones(size(x));
end
%rho=(sqrt(5)+1)/2;

if isfield(Params,'rho')
rho=Params.rho;
else
rho=1;
end


[r,c,L]=size(Y);
Omega= reshape(repmat(Omega,[1 L]), r, c, L);
Y=Y.*Omega;


r1=Params.r1;
itmax=Params.itmax;
%Build A matrix
%B=spdiags(real(AtA(:)),0,n,n);
%spectral initialization 

z0 = randn(r,c); z0 = z0/norm(z0,'fro'); % Initial guess 



normest = sqrt(sum(Y(:))/numel(Y)); % Estimate norm to scale eigenvector
z = normest * z0;                   % Apply scaling 


u0=abs(z);


uInit=u0;

z0= A(u0);
v0=zeros(r,c,L);
sqrtY=sqrt(Y);
for ii=1:itmax
       %step I for u
       g=real(At((z0+v0/r1)));
       

       u=g./AtA;
       %step II for z
       tmp=A(u)-v0/r1;
      
       %z=(sign(tmp).*(abs(tmp)+sqrt(abs(tmp).^2+4*r1*(1+r1)*Y))/2/(1+r1));
       z=(sqrtY+r1*abs(tmp))./(1+r1).*sign(tmp);
       %Step III; updat for multipliers
       v=v0+rho*r1*(z-A(u));       
       %% update the variables
       v0=v;
       z0=z;

end


%profile viewer
end