function [u,uInit,errGroup,rf]=solverPRPoisson(Y,x,A,At,Params,AtA,Omega)
%profile on
 [r,c,L]=size(Y);
 
if nargin>=7
Omega= reshape(repmat(Omega,[1 L]), r, c, L);
Y=Y.*Omega;
end

if isfield(Params,'rho')
rho=Params.rho;
else
rho=1;
end

if ~isfield(Params,'tol')
    tol=eps;
else
    tol=Params.tol;
end


verbose=0;

r1=Params.r1;
itmax=Params.itmax;

if ~isfield('Params','init')
z0 = randn(r,c); z0 = z0/norm(z0,'fro'); % Initial guess 
normest = sqrt(sum(Y(:))/numel(Y)); % Estimate norm to scale eigenvector
z = normest * z0;                   % Apply scaling 
u0=abs(z);
%
else
u0=Params.init;
end


uInit=u0;

z0= A(u0);
v0=zeros(r,c,L);

for ii=1:itmax
    
    [~,scale]=snrComptC(u0,x);errGroup(ii)=norm(scale*u0-x,'fro');
    rf(ii)=rfComput(u0,A,Y);
    %step I for u
    if isreal(x)
        u=real(At((z0+v0/r1)))./AtA;
    else
        u=(At((z0+v0/r1)))./AtA;
    end
       u0=u;        
       %step II for z
       tmp=A(u)-v0/r1;
       if nargin==7
      % z=(sign(tmp).*(abs(tmp)+sqrt(abs(tmp).^2+4*r1*(1+r1)*Y))/2/(1+r1)).*Omega+(1-Omega).*tmp;
        z=(sign(tmp).*(r1*abs(tmp)+sqrt(r1^2*abs(tmp).^2+4*(1+r1)*Y))/2/(1+r1)).*Omega+(1-Omega).*tmp;
       else
       z=sign(tmp).*(r1*abs(tmp)+sqrt(r1^2*abs(tmp).^2+4*(1+r1)*Y))/2/(1+r1);
       
       fflag=(tmp==0);z=ones(size(fflag)).*fflag+(1-fflag).*z;
       
       %z=(1+sqrt(1+4*r1*(1+r1)*Y./(abs(tmp).^2))).*tmp/(2*(1+r1));
       %z=(1+sqrt(1+4*r0*(1+r0)*Y./(abs(tmp).^2))).*tmp/(2*(1+r0));
       end
       %Step III; updat for multipliers
       v=v0+rho*r1*(z-A(u));       
       %% update the variables
       v0=v;
       z0=z;
       
       %errGroup(ii)= norm(abs(u(:))-x(:),'fro')/norm(x(:));
       
       if verbose==1
       figure(1);imshow(u,[]);
       title([num2str(ii),'_{th} SNR=',num2str(snrComptC(u,x))]);
       drawnow;
       end
              
       
       if  errGroup(ii)<=tol
        disp(['After',num2str(ii),'_th iteration, PR stopped!'])
        break
    end

end


%profile viewer
end